//////////////////////////////////////////
//
// NOTE: This is *not* a valid shader file
//
///////////////////////////////////////////
Shader "Shader Graphs/Nuare_GrassUnlit" {
    Properties {
        _MainTex ("MainTex", 2D) = "white" { }
        _Tint ("Tint", Color) = (1,1,1,1)
        _Cutout_Threshold ("Cutout Threshold", Range(0, 1)) = 0.5
        _Ground_Height ("Ground Height", Float) = 0
        _Grass_Height ("Grass Height", Float) = 1
        _Wind_Direction ("Wind Direction", Vector) = (0,0,1,0)
        _Wind_Displacement ("Wind Displacement", Float) = 0.1
        _Wind_Normal_Factor ("Wind Normal Factor", Range(0, 1)) = 0.5
        _QueueOffset ("_QueueOffset", Float) = 0
        _QueueControl ("_QueueControl", Float) = -1
        unity_Lightmaps ("unity_Lightmaps", 2DArray) = "" { }
        unity_LightmapsInd ("unity_LightmapsInd", 2DArray) = "" { }
        unity_ShadowMasks ("unity_ShadowMasks", 2DArray) = "" { }
    }
    SubShader {
        Tags { "DisableBatching" = "False" "QUEUE" = "AlphaTest" "RenderPipeline" = "UniversalPipeline" "RenderType" = "Opaque" "ShaderGraphShader" = "true" "ShaderGraphTargetId" = "UniversalUnlitSubTarget" "UniversalMaterialType" = "Unlit" }
        Pass {
            Name "Universal Forward"
            Tags { "DisableBatching" = "False" "QUEUE" = "AlphaTest" "RenderPipeline" = "UniversalPipeline" "RenderType" = "Opaque" "ShaderGraphShader" = "true" "ShaderGraphTargetId" = "UniversalUnlitSubTarget" "UniversalMaterialType" = "Unlit" }
            AlphaToMask On
            Cull Off
            GpuProgramID 40377
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    Keywords { "_SCREEN_SPACE_OCCLUSION" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _TimeParameters;
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(1) uniform UnityPerDraw {
                    #endif
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_ObjectToWorld[4];
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_WorldToObject[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LODFade;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_WorldTransformParams;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RenderingLayer;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightData;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightIndices[2];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_ProbesOcclusion;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_DynamicLightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHC;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Min;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Max;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousM[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousMI[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_MotionVectorsParams;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    in highp vec3 in_POSITION0;
                    in highp vec3 in_NORMAL0;
                    in highp vec4 in_TEXCOORD0;
                    out highp vec4 vs_INTERP0;
                    out highp vec3 vs_INTERP1;
                    out highp vec3 vs_INTERP2;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    vec3 u_xlat2;
                    ivec2 u_xlati2;
                    vec4 u_xlat3;
                    ivec4 u_xlati3;
                    uvec2 u_xlatu3;
                    vec4 u_xlat4;
                    vec3 u_xlat5;
                    vec3 u_xlat6;
                    vec3 u_xlat9;
                    vec2 u_xlat12;
                    ivec2 u_xlati12;
                    uint u_xlatu12;
                    vec2 u_xlat14;
                    ivec2 u_xlati14;
                    uvec2 u_xlatu14;
                    float u_xlat18;
                    int u_xlati18;
                    uint u_xlatu18;
                    float u_xlat19;
                    int u_xlati19;
                    uint u_xlatu19;
                    void main()
                    {
                        u_xlat0.xy = _Wind_Direction.zy * vec2(1.0, 0.0);
                        u_xlat0 = _Wind_Direction.yxyx * vec4(0.0, 1.0, 0.0, 1.0) + (-u_xlat0.xyxy);
                        u_xlat1.xyz = in_POSITION0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * in_POSITION0.xxx + u_xlat1.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * in_POSITION0.zzz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat0.x = dot(u_xlat0.xzyw, u_xlat1.xxzz);
                        u_xlat6.x = dot(_Wind_Direction.xyz, u_xlat1.xyz);
                        u_xlat0.x = u_xlat6.x * 30.0 + u_xlat0.x;
                        u_xlat0.y = fract(u_xlat0.x);
                        u_xlat0.z = _TimeParameters.x + _TimeParameters.x;
                        u_xlat2.xy = floor(u_xlat0.zx);
                        u_xlat0.x = fract(u_xlat0.z);
                        u_xlat12.xy = u_xlat2.xy + vec2(1.0, 1.0);
                        u_xlati12.xy = ivec2(u_xlat12.xy);
                        u_xlati18 = int(uint(uint(u_xlati12.y) ^ 1103515245u));
                        u_xlati12.x = u_xlati18 + u_xlati12.x;
                        u_xlatu12 = uint(u_xlati18) * uint(u_xlati12.x);
                        u_xlatu18 = uint(u_xlatu12 >> (5u & uint(0x1F)));
                        u_xlati12.x = int(uint(u_xlatu18 ^ u_xlatu12));
                        u_xlatu12 = uint(u_xlati12.x) * 668265261u;
                        u_xlatu12 = uint(u_xlatu12 >> (8u & uint(0x1F)));
                        u_xlat12.x = float(u_xlatu12);
                        u_xlat3.yz = u_xlat12.xx * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat18 = floor(u_xlat3.y);
                        u_xlat3.x = u_xlat12.x * 5.96046519e-08 + (-u_xlat18);
                        u_xlat12.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat12.x = inversesqrt(u_xlat12.x);
                        u_xlat12.xy = u_xlat12.xx * u_xlat3.xz;
                        u_xlat14.xy = u_xlat0.xy + vec2(-1.0, -1.0);
                        u_xlat12.x = dot(u_xlat12.xy, u_xlat14.xy);
                        u_xlat3 = u_xlat2.xyxy + vec4(0.0, 1.0, 1.0, 0.0);
                        u_xlati2.xy = ivec2(u_xlat2.xy);
                        u_xlati3 = ivec4(u_xlat3);
                        u_xlati14.xy = ivec2(uvec2(uint(u_xlati3.y) ^ uint(1103515245u), uint(u_xlati3.w) ^ uint(1103515245u)));
                        u_xlati3.xy = u_xlati14.xy + u_xlati3.xz;
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(u_xlati3.xy);
                        u_xlatu3.xy = uvec2(u_xlatu14.x >> (uint(5u) & uint(0x1F)), u_xlatu14.y >> (uint(5u) & uint(0x1F)));
                        u_xlati14.xy = ivec2(uvec2(u_xlatu14.x ^ u_xlatu3.x, u_xlatu14.y ^ u_xlatu3.y));
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(668265261u, 668265261u);
                        u_xlatu14.xy = uvec2(u_xlatu14.x >> (uint(8u) & uint(0x1F)), u_xlatu14.y >> (uint(8u) & uint(0x1F)));
                        u_xlat14.xy = vec2(u_xlatu14.xy);
                        u_xlat3 = u_xlat14.xyxy * vec4(5.96046519e-08, 5.96046519e-08, 5.96046519e-08, 5.96046519e-08) + vec4(0.5, 0.5, -0.5, -0.5);
                        u_xlat4.xy = floor(u_xlat3.xy);
                        u_xlat3.xy = u_xlat14.xy * vec2(5.96046519e-08, 5.96046519e-08) + (-u_xlat4.xy);
                        u_xlat18 = dot(u_xlat3.yw, u_xlat3.yw);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat14.xy = vec2(u_xlat18) * u_xlat3.yw;
                        u_xlat4 = u_xlat0.xyxy + vec4(-0.0, -1.0, -1.0, -0.0);
                        u_xlat18 = dot(u_xlat14.xy, u_xlat4.zw);
                        u_xlat12.x = (-u_xlat18) + u_xlat12.x;
                        u_xlat14.xy = u_xlat0.xy * u_xlat0.xy;
                        u_xlat14.xy = u_xlat0.xy * u_xlat14.xy;
                        u_xlat9.xz = u_xlat0.xy * vec2(6.0, 6.0) + vec2(-15.0, -15.0);
                        u_xlat9.xz = u_xlat0.xy * u_xlat9.xz + vec2(10.0, 10.0);
                        u_xlat14.xy = u_xlat14.xy * u_xlat9.xz;
                        u_xlat12.x = u_xlat14.y * u_xlat12.x + u_xlat18;
                        u_xlati18 = int(uint(uint(u_xlati2.y) ^ 1103515245u));
                        u_xlati19 = u_xlati18 + u_xlati2.x;
                        u_xlatu18 = uint(u_xlati18) * uint(u_xlati19);
                        u_xlatu19 = uint(u_xlatu18 >> (5u & uint(0x1F)));
                        u_xlati18 = int(uint(u_xlatu18 ^ u_xlatu19));
                        u_xlatu18 = uint(u_xlati18) * 668265261u;
                        u_xlatu18 = uint(u_xlatu18 >> (8u & uint(0x1F)));
                        u_xlat18 = float(u_xlatu18);
                        u_xlat5.yz = vec2(u_xlat18) * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat19 = floor(u_xlat5.y);
                        u_xlat5.x = u_xlat18 * 5.96046519e-08 + (-u_xlat19);
                        u_xlat18 = dot(u_xlat5.xz, u_xlat5.xz);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat2.xy = vec2(u_xlat18) * u_xlat5.xz;
                        u_xlat0.x = dot(u_xlat2.xy, u_xlat0.xy);
                        u_xlat6.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xz = u_xlat6.xx * u_xlat3.xz;
                        u_xlat6.x = dot(u_xlat6.xz, u_xlat4.xy);
                        u_xlat6.x = (-u_xlat0.x) + u_xlat6.x;
                        u_xlat0.x = u_xlat14.y * u_xlat6.x + u_xlat0.x;
                        u_xlat6.x = (-u_xlat0.x) + u_xlat12.x;
                        u_xlat0.x = u_xlat14.x * u_xlat6.x + u_xlat0.x;
                        u_xlat0.x = u_xlat0.x + 1.29999995;
                        u_xlat0.x = u_xlat0.x * 0.555555582;
                        u_xlat0.x = clamp(u_xlat0.x, 0.0, 1.0);
                        u_xlat6.x = u_xlat0.x * -2.0 + 3.0;
                        u_xlat0.x = u_xlat0.x * u_xlat0.x;
                        u_xlat0.x = dot(u_xlat6.xx, u_xlat0.xx);
                        u_xlat2.x = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[0].xyz);
                        u_xlat2.y = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[1].xyz);
                        u_xlat2.z = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[2].xyz);
                        u_xlat6.x = dot(u_xlat2.xyz, u_xlat2.xyz);
                        u_xlat6.x = max(u_xlat6.x, 1.17549435e-38);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xyz = u_xlat6.xxx * u_xlat2.xyz;
                        u_xlat19 = dot(_Wind_Direction.xyz, u_xlat6.xyz);
                        vs_INTERP2.xyz = u_xlat6.xyz;
                        u_xlat6.x = abs(u_xlat19) + -1.0;
                        u_xlat6.x = _Wind_Normal_Factor * u_xlat6.x + 1.0;
                        u_xlat0.x = u_xlat6.x * u_xlat0.x;
                        u_xlat6.x = u_xlat1.y + (-_Ground_Height);
                        u_xlat12.x = (-_Ground_Height) + _Grass_Height;
                        u_xlat12.x = float(1.0) / u_xlat12.x;
                        u_xlat6.x = u_xlat12.x * u_xlat6.x;
                        u_xlat6.x = clamp(u_xlat6.x, 0.0, 1.0);
                        u_xlat12.x = u_xlat6.x * -2.0 + 3.0;
                        u_xlat6.x = u_xlat6.x * u_xlat6.x;
                        u_xlat6.x = u_xlat6.x * u_xlat12.x;
                        u_xlat0.x = u_xlat6.x * u_xlat0.x;
                        u_xlat0.x = u_xlat0.x * _Wind_Displacement;
                        u_xlat0.xyz = u_xlat0.xxx * _Wind_Direction.xyz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat0.yyy * hlslcc_mtx4x4unity_WorldToObject[1].xyz;
                        u_xlat0.xyw = hlslcc_mtx4x4unity_WorldToObject[0].xyz * u_xlat0.xxx + u_xlat1.xyz;
                        u_xlat0.xyz = hlslcc_mtx4x4unity_WorldToObject[2].xyz * u_xlat0.zzz + u_xlat0.xyw;
                        u_xlat0.xyz = u_xlat0.xyz + hlslcc_mtx4x4unity_WorldToObject[3].xyz;
                        u_xlat1.xyz = u_xlat0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat0.xyw = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * u_xlat0.xxx + u_xlat1.xyz;
                        u_xlat0.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * u_xlat0.zzz + u_xlat0.xyw;
                        u_xlat0.xyz = u_xlat0.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        vs_INTERP1.xyz = u_xlat0.xyz;
                        gl_Position = u_xlat1 + hlslcc_mtx4x4unity_MatrixVP[3];
                        vs_INTERP0 = in_TEXCOORD0;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _ScaledScreenParams;
                    uniform 	vec2 _GlobalMipBias;
                    uniform 	float _AlphaToMaskAvailable;
                    uniform 	vec4 _AmbientOcclusionParam;
                    uniform 	vec4 unity_AmbientSky;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _ScreenSpaceOcclusionTexture;
                    UNITY_LOCATION(1) uniform mediump sampler2D _MainTex;
                    in highp vec4 vs_INTERP0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_Target0;
                    #else
                    layout(location = 0) out highp vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    vec2 u_xlat1;
                    float u_xlat3;
                    bool u_xlatb3;
                    bool u_xlatb5;
                    float u_xlat6;
                    bool u_xlatb6;
                    void main()
                    {
                    vec4 hlslcc_FragCoord = vec4(gl_FragCoord.xyz, 1.0/gl_FragCoord.w);
                        u_xlat0 = texture(_MainTex, vs_INTERP0.xy, _GlobalMipBias.x);
                        u_xlat1.x = dFdx(u_xlat0.w);
                        u_xlat3 = dFdy(u_xlat0.w);
                        u_xlat1.x = abs(u_xlat3) + abs(u_xlat1.x);
                        u_xlat1.x = max(u_xlat1.x, 9.99999975e-05);
                        u_xlat3 = u_xlat0.w + (-_Cutout_Threshold);
                        u_xlat1.x = u_xlat3 / u_xlat1.x;
                        u_xlat1.x = u_xlat1.x + 0.5;
                        u_xlat1.x = clamp(u_xlat1.x, 0.0, 1.0);
                        u_xlatb3 = 0.0>=_Cutout_Threshold;
                        u_xlat1.x = (u_xlatb3) ? 1.0 : u_xlat1.x;
                        u_xlatb3 = _AlphaToMaskAvailable!=0.0;
                        u_xlatb5 = u_xlat0.w>=_Cutout_Threshold;
                        u_xlat6 = u_xlatb5 ? u_xlat0.w : float(0.0);
                        u_xlat0.xyz = u_xlat0.xyz * unity_AmbientSky.xyz;
                        u_xlat6 = (u_xlatb3) ? u_xlat1.x : u_xlat6;
                        SV_Target0.w = (u_xlatb3) ? u_xlat1.x : 1.0;
                        u_xlat6 = u_xlat6 + -9.99999975e-05;
                        u_xlatb6 = u_xlat6<0.0;
                        if(u_xlatb6){discard;}
                        u_xlat1.xy = vec2(1.0) / vec2(_ScaledScreenParams.xy);
                        u_xlat1.xy = u_xlat1.xy * hlslcc_FragCoord.xy;
                        u_xlat6 = texture(_ScreenSpaceOcclusionTexture, u_xlat1.xy, _GlobalMipBias.x).x;
                        u_xlat1.x = (-_AmbientOcclusionParam.x) + 1.0;
                        u_xlat6 = u_xlat6 + u_xlat1.x;
                        u_xlat6 = clamp(u_xlat6, 0.0, 1.0);
                        u_xlat6 = u_xlat6 + -1.0;
                        u_xlat6 = _AmbientOcclusionParam.w * u_xlat6 + 1.0;
                        SV_Target0.xyz = vec3(u_xlat6) * u_xlat0.xyz;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
        Pass {
            Name "DepthOnly"
            Tags { "DisableBatching" = "False" "LIGHTMODE" = "DepthOnly" "QUEUE" = "AlphaTest" "RenderPipeline" = "UniversalPipeline" "RenderType" = "Opaque" "ShaderGraphShader" = "true" "ShaderGraphTargetId" = "UniversalUnlitSubTarget" "UniversalMaterialType" = "Unlit" }
            ColorMask B 0
            Cull Off
            GpuProgramID 95392
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _TimeParameters;
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(1) uniform UnityPerDraw {
                    #endif
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_ObjectToWorld[4];
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_WorldToObject[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LODFade;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_WorldTransformParams;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RenderingLayer;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightData;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightIndices[2];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_ProbesOcclusion;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_DynamicLightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHC;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Min;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Max;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousM[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousMI[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_MotionVectorsParams;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    in highp vec3 in_POSITION0;
                    in highp vec3 in_NORMAL0;
                    in highp vec4 in_TEXCOORD0;
                    out highp vec4 vs_INTERP0;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    vec3 u_xlat2;
                    ivec2 u_xlati2;
                    vec4 u_xlat3;
                    ivec4 u_xlati3;
                    uvec2 u_xlatu3;
                    vec4 u_xlat4;
                    vec3 u_xlat5;
                    vec3 u_xlat6;
                    vec3 u_xlat9;
                    vec2 u_xlat12;
                    ivec2 u_xlati12;
                    uint u_xlatu12;
                    vec2 u_xlat14;
                    ivec2 u_xlati14;
                    uvec2 u_xlatu14;
                    float u_xlat18;
                    int u_xlati18;
                    uint u_xlatu18;
                    float u_xlat19;
                    int u_xlati19;
                    uint u_xlatu19;
                    void main()
                    {
                        u_xlat0.xy = _Wind_Direction.zy * vec2(1.0, 0.0);
                        u_xlat0 = _Wind_Direction.yxyx * vec4(0.0, 1.0, 0.0, 1.0) + (-u_xlat0.xyxy);
                        u_xlat1.xyz = in_POSITION0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * in_POSITION0.xxx + u_xlat1.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * in_POSITION0.zzz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat0.x = dot(u_xlat0.xzyw, u_xlat1.xxzz);
                        u_xlat6.x = dot(_Wind_Direction.xyz, u_xlat1.xyz);
                        u_xlat0.x = u_xlat6.x * 30.0 + u_xlat0.x;
                        u_xlat0.y = fract(u_xlat0.x);
                        u_xlat0.z = _TimeParameters.x + _TimeParameters.x;
                        u_xlat2.xy = floor(u_xlat0.zx);
                        u_xlat0.x = fract(u_xlat0.z);
                        u_xlat12.xy = u_xlat2.xy + vec2(1.0, 1.0);
                        u_xlati12.xy = ivec2(u_xlat12.xy);
                        u_xlati18 = int(uint(uint(u_xlati12.y) ^ 1103515245u));
                        u_xlati12.x = u_xlati18 + u_xlati12.x;
                        u_xlatu12 = uint(u_xlati18) * uint(u_xlati12.x);
                        u_xlatu18 = uint(u_xlatu12 >> (5u & uint(0x1F)));
                        u_xlati12.x = int(uint(u_xlatu18 ^ u_xlatu12));
                        u_xlatu12 = uint(u_xlati12.x) * 668265261u;
                        u_xlatu12 = uint(u_xlatu12 >> (8u & uint(0x1F)));
                        u_xlat12.x = float(u_xlatu12);
                        u_xlat3.yz = u_xlat12.xx * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat18 = floor(u_xlat3.y);
                        u_xlat3.x = u_xlat12.x * 5.96046519e-08 + (-u_xlat18);
                        u_xlat12.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat12.x = inversesqrt(u_xlat12.x);
                        u_xlat12.xy = u_xlat12.xx * u_xlat3.xz;
                        u_xlat14.xy = u_xlat0.xy + vec2(-1.0, -1.0);
                        u_xlat12.x = dot(u_xlat12.xy, u_xlat14.xy);
                        u_xlat3 = u_xlat2.xyxy + vec4(0.0, 1.0, 1.0, 0.0);
                        u_xlati2.xy = ivec2(u_xlat2.xy);
                        u_xlati3 = ivec4(u_xlat3);
                        u_xlati14.xy = ivec2(uvec2(uint(u_xlati3.y) ^ uint(1103515245u), uint(u_xlati3.w) ^ uint(1103515245u)));
                        u_xlati3.xy = u_xlati14.xy + u_xlati3.xz;
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(u_xlati3.xy);
                        u_xlatu3.xy = uvec2(u_xlatu14.x >> (uint(5u) & uint(0x1F)), u_xlatu14.y >> (uint(5u) & uint(0x1F)));
                        u_xlati14.xy = ivec2(uvec2(u_xlatu14.x ^ u_xlatu3.x, u_xlatu14.y ^ u_xlatu3.y));
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(668265261u, 668265261u);
                        u_xlatu14.xy = uvec2(u_xlatu14.x >> (uint(8u) & uint(0x1F)), u_xlatu14.y >> (uint(8u) & uint(0x1F)));
                        u_xlat14.xy = vec2(u_xlatu14.xy);
                        u_xlat3 = u_xlat14.xyxy * vec4(5.96046519e-08, 5.96046519e-08, 5.96046519e-08, 5.96046519e-08) + vec4(0.5, 0.5, -0.5, -0.5);
                        u_xlat4.xy = floor(u_xlat3.xy);
                        u_xlat3.xy = u_xlat14.xy * vec2(5.96046519e-08, 5.96046519e-08) + (-u_xlat4.xy);
                        u_xlat18 = dot(u_xlat3.yw, u_xlat3.yw);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat14.xy = vec2(u_xlat18) * u_xlat3.yw;
                        u_xlat4 = u_xlat0.xyxy + vec4(-0.0, -1.0, -1.0, -0.0);
                        u_xlat18 = dot(u_xlat14.xy, u_xlat4.zw);
                        u_xlat12.x = (-u_xlat18) + u_xlat12.x;
                        u_xlat14.xy = u_xlat0.xy * u_xlat0.xy;
                        u_xlat14.xy = u_xlat0.xy * u_xlat14.xy;
                        u_xlat9.xz = u_xlat0.xy * vec2(6.0, 6.0) + vec2(-15.0, -15.0);
                        u_xlat9.xz = u_xlat0.xy * u_xlat9.xz + vec2(10.0, 10.0);
                        u_xlat14.xy = u_xlat14.xy * u_xlat9.xz;
                        u_xlat12.x = u_xlat14.y * u_xlat12.x + u_xlat18;
                        u_xlati18 = int(uint(uint(u_xlati2.y) ^ 1103515245u));
                        u_xlati19 = u_xlati18 + u_xlati2.x;
                        u_xlatu18 = uint(u_xlati18) * uint(u_xlati19);
                        u_xlatu19 = uint(u_xlatu18 >> (5u & uint(0x1F)));
                        u_xlati18 = int(uint(u_xlatu18 ^ u_xlatu19));
                        u_xlatu18 = uint(u_xlati18) * 668265261u;
                        u_xlatu18 = uint(u_xlatu18 >> (8u & uint(0x1F)));
                        u_xlat18 = float(u_xlatu18);
                        u_xlat5.yz = vec2(u_xlat18) * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat19 = floor(u_xlat5.y);
                        u_xlat5.x = u_xlat18 * 5.96046519e-08 + (-u_xlat19);
                        u_xlat18 = dot(u_xlat5.xz, u_xlat5.xz);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat2.xy = vec2(u_xlat18) * u_xlat5.xz;
                        u_xlat0.x = dot(u_xlat2.xy, u_xlat0.xy);
                        u_xlat6.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xz = u_xlat6.xx * u_xlat3.xz;
                        u_xlat6.x = dot(u_xlat6.xz, u_xlat4.xy);
                        u_xlat6.x = (-u_xlat0.x) + u_xlat6.x;
                        u_xlat0.x = u_xlat14.y * u_xlat6.x + u_xlat0.x;
                        u_xlat6.x = (-u_xlat0.x) + u_xlat12.x;
                        u_xlat0.x = u_xlat14.x * u_xlat6.x + u_xlat0.x;
                        u_xlat0.x = u_xlat0.x + 1.29999995;
                        u_xlat0.x = u_xlat0.x * 0.555555582;
                        u_xlat0.x = clamp(u_xlat0.x, 0.0, 1.0);
                        u_xlat6.x = u_xlat0.x * -2.0 + 3.0;
                        u_xlat0.x = u_xlat0.x * u_xlat0.x;
                        u_xlat0.x = dot(u_xlat6.xx, u_xlat0.xx);
                        u_xlat2.x = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[0].xyz);
                        u_xlat2.y = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[1].xyz);
                        u_xlat2.z = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[2].xyz);
                        u_xlat6.x = dot(u_xlat2.xyz, u_xlat2.xyz);
                        u_xlat6.x = max(u_xlat6.x, 1.17549435e-38);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xyz = u_xlat6.xxx * u_xlat2.xyz;
                        u_xlat6.x = dot(_Wind_Direction.xyz, u_xlat6.xyz);
                        u_xlat6.x = abs(u_xlat6.x) + -1.0;
                        u_xlat6.x = _Wind_Normal_Factor * u_xlat6.x + 1.0;
                        u_xlat0.x = u_xlat6.x * u_xlat0.x;
                        u_xlat6.x = u_xlat1.y + (-_Ground_Height);
                        u_xlat12.x = (-_Ground_Height) + _Grass_Height;
                        u_xlat12.x = float(1.0) / u_xlat12.x;
                        u_xlat6.x = u_xlat12.x * u_xlat6.x;
                        u_xlat6.x = clamp(u_xlat6.x, 0.0, 1.0);
                        u_xlat12.x = u_xlat6.x * -2.0 + 3.0;
                        u_xlat6.x = u_xlat6.x * u_xlat6.x;
                        u_xlat6.x = u_xlat6.x * u_xlat12.x;
                        u_xlat0.x = u_xlat6.x * u_xlat0.x;
                        u_xlat0.x = u_xlat0.x * _Wind_Displacement;
                        u_xlat0.xyz = u_xlat0.xxx * _Wind_Direction.xyz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat0.yyy * hlslcc_mtx4x4unity_WorldToObject[1].xyz;
                        u_xlat0.xyw = hlslcc_mtx4x4unity_WorldToObject[0].xyz * u_xlat0.xxx + u_xlat1.xyz;
                        u_xlat0.xyz = hlslcc_mtx4x4unity_WorldToObject[2].xyz * u_xlat0.zzz + u_xlat0.xyw;
                        u_xlat0.xyz = u_xlat0.xyz + hlslcc_mtx4x4unity_WorldToObject[3].xyz;
                        u_xlat1.xyz = u_xlat0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat0.xyw = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * u_xlat0.xxx + u_xlat1.xyz;
                        u_xlat0.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * u_xlat0.zzz + u_xlat0.xyw;
                        u_xlat0.xyz = u_xlat0.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        gl_Position = u_xlat0 + hlslcc_mtx4x4unity_MatrixVP[3];
                        vs_INTERP0 = in_TEXCOORD0;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec2 _GlobalMipBias;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in highp vec4 vs_INTERP0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_TARGET0;
                    #else
                    layout(location = 0) out highp vec4 SV_TARGET0;
                    #endif
                    float u_xlat0;
                    bool u_xlatb0;
                    void main()
                    {
                    vec4 hlslcc_FragCoord = vec4(gl_FragCoord.xyz, 1.0/gl_FragCoord.w);
                        u_xlat0 = texture(_MainTex, vs_INTERP0.xy, _GlobalMipBias.x).w;
                        u_xlat0 = u_xlat0 + (-_Cutout_Threshold);
                        u_xlatb0 = u_xlat0<0.0;
                        if(u_xlatb0){discard;}
                        SV_TARGET0 = hlslcc_FragCoord.zzzz;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
        Pass {
            Name "DepthNormalsOnly"
            Tags { "DisableBatching" = "False" "LIGHTMODE" = "DepthNormalsOnly" "QUEUE" = "AlphaTest" "RenderPipeline" = "UniversalPipeline" "RenderType" = "Opaque" "ShaderGraphShader" = "true" "ShaderGraphTargetId" = "UniversalUnlitSubTarget" "UniversalMaterialType" = "Unlit" }
            Cull Off
            GpuProgramID 181002
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _TimeParameters;
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(1) uniform UnityPerDraw {
                    #endif
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_ObjectToWorld[4];
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_WorldToObject[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LODFade;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_WorldTransformParams;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RenderingLayer;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightData;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightIndices[2];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_ProbesOcclusion;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_DynamicLightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHC;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Min;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Max;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousM[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousMI[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_MotionVectorsParams;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    in highp vec3 in_POSITION0;
                    in highp vec3 in_NORMAL0;
                    in highp vec4 in_TEXCOORD0;
                    out highp vec4 vs_INTERP0;
                    out highp vec3 vs_INTERP1;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    vec3 u_xlat2;
                    ivec2 u_xlati2;
                    vec4 u_xlat3;
                    ivec4 u_xlati3;
                    uvec2 u_xlatu3;
                    vec4 u_xlat4;
                    vec3 u_xlat5;
                    vec3 u_xlat6;
                    vec3 u_xlat9;
                    vec2 u_xlat12;
                    ivec2 u_xlati12;
                    uint u_xlatu12;
                    vec2 u_xlat14;
                    ivec2 u_xlati14;
                    uvec2 u_xlatu14;
                    float u_xlat18;
                    int u_xlati18;
                    uint u_xlatu18;
                    float u_xlat19;
                    int u_xlati19;
                    uint u_xlatu19;
                    void main()
                    {
                        u_xlat0.xy = _Wind_Direction.zy * vec2(1.0, 0.0);
                        u_xlat0 = _Wind_Direction.yxyx * vec4(0.0, 1.0, 0.0, 1.0) + (-u_xlat0.xyxy);
                        u_xlat1.xyz = in_POSITION0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * in_POSITION0.xxx + u_xlat1.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * in_POSITION0.zzz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat0.x = dot(u_xlat0.xzyw, u_xlat1.xxzz);
                        u_xlat6.x = dot(_Wind_Direction.xyz, u_xlat1.xyz);
                        u_xlat0.x = u_xlat6.x * 30.0 + u_xlat0.x;
                        u_xlat0.y = fract(u_xlat0.x);
                        u_xlat0.z = _TimeParameters.x + _TimeParameters.x;
                        u_xlat2.xy = floor(u_xlat0.zx);
                        u_xlat0.x = fract(u_xlat0.z);
                        u_xlat12.xy = u_xlat2.xy + vec2(1.0, 1.0);
                        u_xlati12.xy = ivec2(u_xlat12.xy);
                        u_xlati18 = int(uint(uint(u_xlati12.y) ^ 1103515245u));
                        u_xlati12.x = u_xlati18 + u_xlati12.x;
                        u_xlatu12 = uint(u_xlati18) * uint(u_xlati12.x);
                        u_xlatu18 = uint(u_xlatu12 >> (5u & uint(0x1F)));
                        u_xlati12.x = int(uint(u_xlatu18 ^ u_xlatu12));
                        u_xlatu12 = uint(u_xlati12.x) * 668265261u;
                        u_xlatu12 = uint(u_xlatu12 >> (8u & uint(0x1F)));
                        u_xlat12.x = float(u_xlatu12);
                        u_xlat3.yz = u_xlat12.xx * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat18 = floor(u_xlat3.y);
                        u_xlat3.x = u_xlat12.x * 5.96046519e-08 + (-u_xlat18);
                        u_xlat12.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat12.x = inversesqrt(u_xlat12.x);
                        u_xlat12.xy = u_xlat12.xx * u_xlat3.xz;
                        u_xlat14.xy = u_xlat0.xy + vec2(-1.0, -1.0);
                        u_xlat12.x = dot(u_xlat12.xy, u_xlat14.xy);
                        u_xlat3 = u_xlat2.xyxy + vec4(0.0, 1.0, 1.0, 0.0);
                        u_xlati2.xy = ivec2(u_xlat2.xy);
                        u_xlati3 = ivec4(u_xlat3);
                        u_xlati14.xy = ivec2(uvec2(uint(u_xlati3.y) ^ uint(1103515245u), uint(u_xlati3.w) ^ uint(1103515245u)));
                        u_xlati3.xy = u_xlati14.xy + u_xlati3.xz;
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(u_xlati3.xy);
                        u_xlatu3.xy = uvec2(u_xlatu14.x >> (uint(5u) & uint(0x1F)), u_xlatu14.y >> (uint(5u) & uint(0x1F)));
                        u_xlati14.xy = ivec2(uvec2(u_xlatu14.x ^ u_xlatu3.x, u_xlatu14.y ^ u_xlatu3.y));
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(668265261u, 668265261u);
                        u_xlatu14.xy = uvec2(u_xlatu14.x >> (uint(8u) & uint(0x1F)), u_xlatu14.y >> (uint(8u) & uint(0x1F)));
                        u_xlat14.xy = vec2(u_xlatu14.xy);
                        u_xlat3 = u_xlat14.xyxy * vec4(5.96046519e-08, 5.96046519e-08, 5.96046519e-08, 5.96046519e-08) + vec4(0.5, 0.5, -0.5, -0.5);
                        u_xlat4.xy = floor(u_xlat3.xy);
                        u_xlat3.xy = u_xlat14.xy * vec2(5.96046519e-08, 5.96046519e-08) + (-u_xlat4.xy);
                        u_xlat18 = dot(u_xlat3.yw, u_xlat3.yw);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat14.xy = vec2(u_xlat18) * u_xlat3.yw;
                        u_xlat4 = u_xlat0.xyxy + vec4(-0.0, -1.0, -1.0, -0.0);
                        u_xlat18 = dot(u_xlat14.xy, u_xlat4.zw);
                        u_xlat12.x = (-u_xlat18) + u_xlat12.x;
                        u_xlat14.xy = u_xlat0.xy * u_xlat0.xy;
                        u_xlat14.xy = u_xlat0.xy * u_xlat14.xy;
                        u_xlat9.xz = u_xlat0.xy * vec2(6.0, 6.0) + vec2(-15.0, -15.0);
                        u_xlat9.xz = u_xlat0.xy * u_xlat9.xz + vec2(10.0, 10.0);
                        u_xlat14.xy = u_xlat14.xy * u_xlat9.xz;
                        u_xlat12.x = u_xlat14.y * u_xlat12.x + u_xlat18;
                        u_xlati18 = int(uint(uint(u_xlati2.y) ^ 1103515245u));
                        u_xlati19 = u_xlati18 + u_xlati2.x;
                        u_xlatu18 = uint(u_xlati18) * uint(u_xlati19);
                        u_xlatu19 = uint(u_xlatu18 >> (5u & uint(0x1F)));
                        u_xlati18 = int(uint(u_xlatu18 ^ u_xlatu19));
                        u_xlatu18 = uint(u_xlati18) * 668265261u;
                        u_xlatu18 = uint(u_xlatu18 >> (8u & uint(0x1F)));
                        u_xlat18 = float(u_xlatu18);
                        u_xlat5.yz = vec2(u_xlat18) * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat19 = floor(u_xlat5.y);
                        u_xlat5.x = u_xlat18 * 5.96046519e-08 + (-u_xlat19);
                        u_xlat18 = dot(u_xlat5.xz, u_xlat5.xz);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat2.xy = vec2(u_xlat18) * u_xlat5.xz;
                        u_xlat0.x = dot(u_xlat2.xy, u_xlat0.xy);
                        u_xlat6.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xz = u_xlat6.xx * u_xlat3.xz;
                        u_xlat6.x = dot(u_xlat6.xz, u_xlat4.xy);
                        u_xlat6.x = (-u_xlat0.x) + u_xlat6.x;
                        u_xlat0.x = u_xlat14.y * u_xlat6.x + u_xlat0.x;
                        u_xlat6.x = (-u_xlat0.x) + u_xlat12.x;
                        u_xlat0.x = u_xlat14.x * u_xlat6.x + u_xlat0.x;
                        u_xlat0.x = u_xlat0.x + 1.29999995;
                        u_xlat0.x = u_xlat0.x * 0.555555582;
                        u_xlat0.x = clamp(u_xlat0.x, 0.0, 1.0);
                        u_xlat6.x = u_xlat0.x * -2.0 + 3.0;
                        u_xlat0.x = u_xlat0.x * u_xlat0.x;
                        u_xlat0.x = dot(u_xlat6.xx, u_xlat0.xx);
                        u_xlat2.x = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[0].xyz);
                        u_xlat2.y = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[1].xyz);
                        u_xlat2.z = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[2].xyz);
                        u_xlat6.x = dot(u_xlat2.xyz, u_xlat2.xyz);
                        u_xlat6.x = max(u_xlat6.x, 1.17549435e-38);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xyz = u_xlat6.xxx * u_xlat2.xyz;
                        u_xlat19 = dot(_Wind_Direction.xyz, u_xlat6.xyz);
                        vs_INTERP1.xyz = u_xlat6.xyz;
                        u_xlat6.x = abs(u_xlat19) + -1.0;
                        u_xlat6.x = _Wind_Normal_Factor * u_xlat6.x + 1.0;
                        u_xlat0.x = u_xlat6.x * u_xlat0.x;
                        u_xlat6.x = u_xlat1.y + (-_Ground_Height);
                        u_xlat12.x = (-_Ground_Height) + _Grass_Height;
                        u_xlat12.x = float(1.0) / u_xlat12.x;
                        u_xlat6.x = u_xlat12.x * u_xlat6.x;
                        u_xlat6.x = clamp(u_xlat6.x, 0.0, 1.0);
                        u_xlat12.x = u_xlat6.x * -2.0 + 3.0;
                        u_xlat6.x = u_xlat6.x * u_xlat6.x;
                        u_xlat6.x = u_xlat6.x * u_xlat12.x;
                        u_xlat0.x = u_xlat6.x * u_xlat0.x;
                        u_xlat0.x = u_xlat0.x * _Wind_Displacement;
                        u_xlat0.xyz = u_xlat0.xxx * _Wind_Direction.xyz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat0.yyy * hlslcc_mtx4x4unity_WorldToObject[1].xyz;
                        u_xlat0.xyw = hlslcc_mtx4x4unity_WorldToObject[0].xyz * u_xlat0.xxx + u_xlat1.xyz;
                        u_xlat0.xyz = hlslcc_mtx4x4unity_WorldToObject[2].xyz * u_xlat0.zzz + u_xlat0.xyw;
                        u_xlat0.xyz = u_xlat0.xyz + hlslcc_mtx4x4unity_WorldToObject[3].xyz;
                        u_xlat1.xyz = u_xlat0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat0.xyw = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * u_xlat0.xxx + u_xlat1.xyz;
                        u_xlat0.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * u_xlat0.zzz + u_xlat0.xyw;
                        u_xlat0.xyz = u_xlat0.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        gl_Position = u_xlat0 + hlslcc_mtx4x4unity_MatrixVP[3];
                        vs_INTERP0 = in_TEXCOORD0;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec2 _GlobalMipBias;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in highp vec4 vs_INTERP0;
                    in highp vec3 vs_INTERP1;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_Target0;
                    #else
                    layout(location = 0) out highp vec4 SV_Target0;
                    #endif
                    float u_xlat0;
                    bool u_xlatb0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_INTERP0.xy, _GlobalMipBias.x).w;
                        u_xlat0 = u_xlat0 + (-_Cutout_Threshold);
                        u_xlatb0 = u_xlat0<0.0;
                        if(u_xlatb0){discard;}
                        u_xlat0 = dot(vs_INTERP1.xyz, vs_INTERP1.xyz);
                        u_xlat0 = inversesqrt(u_xlat0);
                        SV_Target0.xyz = vec3(u_xlat0) * vs_INTERP1.xyz;
                        SV_Target0.w = 0.0;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
        Pass {
            Name "ShadowCaster"
            Tags { "DisableBatching" = "False" "LIGHTMODE" = "SHADOWCASTER" "QUEUE" = "AlphaTest" "RenderPipeline" = "UniversalPipeline" "RenderType" = "Opaque" "ShaderGraphShader" = "true" "ShaderGraphTargetId" = "UniversalUnlitSubTarget" "UniversalMaterialType" = "Unlit" }
            ColorMask 0 0
            Cull Off
            GpuProgramID 236476
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _TimeParameters;
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	vec4 _ShadowBias;
                    uniform 	vec3 _LightDirection;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(1) uniform UnityPerDraw {
                    #endif
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_ObjectToWorld[4];
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_WorldToObject[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LODFade;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_WorldTransformParams;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RenderingLayer;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightData;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightIndices[2];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_ProbesOcclusion;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_DynamicLightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHC;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Min;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Max;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousM[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousMI[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_MotionVectorsParams;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    in highp vec3 in_POSITION0;
                    in highp vec3 in_NORMAL0;
                    in highp vec4 in_TEXCOORD0;
                    out highp vec4 vs_INTERP0;
                    out highp vec3 vs_INTERP1;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    vec3 u_xlat2;
                    ivec2 u_xlati2;
                    vec4 u_xlat3;
                    ivec4 u_xlati3;
                    uvec2 u_xlatu3;
                    vec4 u_xlat4;
                    vec3 u_xlat5;
                    vec3 u_xlat6;
                    vec3 u_xlat9;
                    vec2 u_xlat12;
                    ivec2 u_xlati12;
                    uint u_xlatu12;
                    vec2 u_xlat14;
                    ivec2 u_xlati14;
                    uvec2 u_xlatu14;
                    float u_xlat18;
                    int u_xlati18;
                    uint u_xlatu18;
                    float u_xlat19;
                    int u_xlati19;
                    uint u_xlatu19;
                    void main()
                    {
                        u_xlat0.xy = _Wind_Direction.zy * vec2(1.0, 0.0);
                        u_xlat0 = _Wind_Direction.yxyx * vec4(0.0, 1.0, 0.0, 1.0) + (-u_xlat0.xyxy);
                        u_xlat1.xyz = in_POSITION0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * in_POSITION0.xxx + u_xlat1.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * in_POSITION0.zzz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat0.x = dot(u_xlat0.xzyw, u_xlat1.xxzz);
                        u_xlat6.x = dot(_Wind_Direction.xyz, u_xlat1.xyz);
                        u_xlat0.x = u_xlat6.x * 30.0 + u_xlat0.x;
                        u_xlat0.y = fract(u_xlat0.x);
                        u_xlat0.z = _TimeParameters.x + _TimeParameters.x;
                        u_xlat2.xy = floor(u_xlat0.zx);
                        u_xlat0.x = fract(u_xlat0.z);
                        u_xlat12.xy = u_xlat2.xy + vec2(1.0, 1.0);
                        u_xlati12.xy = ivec2(u_xlat12.xy);
                        u_xlati18 = int(uint(uint(u_xlati12.y) ^ 1103515245u));
                        u_xlati12.x = u_xlati18 + u_xlati12.x;
                        u_xlatu12 = uint(u_xlati18) * uint(u_xlati12.x);
                        u_xlatu18 = uint(u_xlatu12 >> (5u & uint(0x1F)));
                        u_xlati12.x = int(uint(u_xlatu18 ^ u_xlatu12));
                        u_xlatu12 = uint(u_xlati12.x) * 668265261u;
                        u_xlatu12 = uint(u_xlatu12 >> (8u & uint(0x1F)));
                        u_xlat12.x = float(u_xlatu12);
                        u_xlat3.yz = u_xlat12.xx * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat18 = floor(u_xlat3.y);
                        u_xlat3.x = u_xlat12.x * 5.96046519e-08 + (-u_xlat18);
                        u_xlat12.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat12.x = inversesqrt(u_xlat12.x);
                        u_xlat12.xy = u_xlat12.xx * u_xlat3.xz;
                        u_xlat14.xy = u_xlat0.xy + vec2(-1.0, -1.0);
                        u_xlat12.x = dot(u_xlat12.xy, u_xlat14.xy);
                        u_xlat3 = u_xlat2.xyxy + vec4(0.0, 1.0, 1.0, 0.0);
                        u_xlati2.xy = ivec2(u_xlat2.xy);
                        u_xlati3 = ivec4(u_xlat3);
                        u_xlati14.xy = ivec2(uvec2(uint(u_xlati3.y) ^ uint(1103515245u), uint(u_xlati3.w) ^ uint(1103515245u)));
                        u_xlati3.xy = u_xlati14.xy + u_xlati3.xz;
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(u_xlati3.xy);
                        u_xlatu3.xy = uvec2(u_xlatu14.x >> (uint(5u) & uint(0x1F)), u_xlatu14.y >> (uint(5u) & uint(0x1F)));
                        u_xlati14.xy = ivec2(uvec2(u_xlatu14.x ^ u_xlatu3.x, u_xlatu14.y ^ u_xlatu3.y));
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(668265261u, 668265261u);
                        u_xlatu14.xy = uvec2(u_xlatu14.x >> (uint(8u) & uint(0x1F)), u_xlatu14.y >> (uint(8u) & uint(0x1F)));
                        u_xlat14.xy = vec2(u_xlatu14.xy);
                        u_xlat3 = u_xlat14.xyxy * vec4(5.96046519e-08, 5.96046519e-08, 5.96046519e-08, 5.96046519e-08) + vec4(0.5, 0.5, -0.5, -0.5);
                        u_xlat4.xy = floor(u_xlat3.xy);
                        u_xlat3.xy = u_xlat14.xy * vec2(5.96046519e-08, 5.96046519e-08) + (-u_xlat4.xy);
                        u_xlat18 = dot(u_xlat3.yw, u_xlat3.yw);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat14.xy = vec2(u_xlat18) * u_xlat3.yw;
                        u_xlat4 = u_xlat0.xyxy + vec4(-0.0, -1.0, -1.0, -0.0);
                        u_xlat18 = dot(u_xlat14.xy, u_xlat4.zw);
                        u_xlat12.x = (-u_xlat18) + u_xlat12.x;
                        u_xlat14.xy = u_xlat0.xy * u_xlat0.xy;
                        u_xlat14.xy = u_xlat0.xy * u_xlat14.xy;
                        u_xlat9.xz = u_xlat0.xy * vec2(6.0, 6.0) + vec2(-15.0, -15.0);
                        u_xlat9.xz = u_xlat0.xy * u_xlat9.xz + vec2(10.0, 10.0);
                        u_xlat14.xy = u_xlat14.xy * u_xlat9.xz;
                        u_xlat12.x = u_xlat14.y * u_xlat12.x + u_xlat18;
                        u_xlati18 = int(uint(uint(u_xlati2.y) ^ 1103515245u));
                        u_xlati19 = u_xlati18 + u_xlati2.x;
                        u_xlatu18 = uint(u_xlati18) * uint(u_xlati19);
                        u_xlatu19 = uint(u_xlatu18 >> (5u & uint(0x1F)));
                        u_xlati18 = int(uint(u_xlatu18 ^ u_xlatu19));
                        u_xlatu18 = uint(u_xlati18) * 668265261u;
                        u_xlatu18 = uint(u_xlatu18 >> (8u & uint(0x1F)));
                        u_xlat18 = float(u_xlatu18);
                        u_xlat5.yz = vec2(u_xlat18) * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat19 = floor(u_xlat5.y);
                        u_xlat5.x = u_xlat18 * 5.96046519e-08 + (-u_xlat19);
                        u_xlat18 = dot(u_xlat5.xz, u_xlat5.xz);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat2.xy = vec2(u_xlat18) * u_xlat5.xz;
                        u_xlat0.x = dot(u_xlat2.xy, u_xlat0.xy);
                        u_xlat6.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xz = u_xlat6.xx * u_xlat3.xz;
                        u_xlat6.x = dot(u_xlat6.xz, u_xlat4.xy);
                        u_xlat6.x = (-u_xlat0.x) + u_xlat6.x;
                        u_xlat0.x = u_xlat14.y * u_xlat6.x + u_xlat0.x;
                        u_xlat6.x = (-u_xlat0.x) + u_xlat12.x;
                        u_xlat0.x = u_xlat14.x * u_xlat6.x + u_xlat0.x;
                        u_xlat0.x = u_xlat0.x + 1.29999995;
                        u_xlat0.x = u_xlat0.x * 0.555555582;
                        u_xlat0.x = clamp(u_xlat0.x, 0.0, 1.0);
                        u_xlat6.x = u_xlat0.x * -2.0 + 3.0;
                        u_xlat0.x = u_xlat0.x * u_xlat0.x;
                        u_xlat0.x = dot(u_xlat6.xx, u_xlat0.xx);
                        u_xlat2.x = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[0].xyz);
                        u_xlat2.y = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[1].xyz);
                        u_xlat2.z = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[2].xyz);
                        u_xlat6.x = dot(u_xlat2.xyz, u_xlat2.xyz);
                        u_xlat6.x = max(u_xlat6.x, 1.17549435e-38);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xyz = u_xlat6.xxx * u_xlat2.xyz;
                        u_xlat19 = dot(_Wind_Direction.xyz, u_xlat6.xyz);
                        u_xlat19 = abs(u_xlat19) + -1.0;
                        u_xlat19 = _Wind_Normal_Factor * u_xlat19 + 1.0;
                        u_xlat0.x = u_xlat0.x * u_xlat19;
                        u_xlat19 = u_xlat1.y + (-_Ground_Height);
                        u_xlat2.x = (-_Ground_Height) + _Grass_Height;
                        u_xlat2.x = float(1.0) / u_xlat2.x;
                        u_xlat19 = u_xlat19 * u_xlat2.x;
                        u_xlat19 = clamp(u_xlat19, 0.0, 1.0);
                        u_xlat2.x = u_xlat19 * -2.0 + 3.0;
                        u_xlat19 = u_xlat19 * u_xlat19;
                        u_xlat19 = u_xlat19 * u_xlat2.x;
                        u_xlat0.x = u_xlat0.x * u_xlat19;
                        u_xlat0.x = u_xlat0.x * _Wind_Displacement;
                        u_xlat1.xyz = u_xlat0.xxx * _Wind_Direction.xyz + u_xlat1.xyz;
                        u_xlat2.xyz = u_xlat1.yyy * hlslcc_mtx4x4unity_WorldToObject[1].xyz;
                        u_xlat1.xyw = hlslcc_mtx4x4unity_WorldToObject[0].xyz * u_xlat1.xxx + u_xlat2.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_WorldToObject[2].xyz * u_xlat1.zzz + u_xlat1.xyw;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_WorldToObject[3].xyz;
                        u_xlat2.xyz = u_xlat1.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat1.xyw = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * u_xlat1.xxx + u_xlat2.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * u_xlat1.zzz + u_xlat1.xyw;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat1.xyz = vec3(_LightDirection.x, _LightDirection.y, _LightDirection.z) * _ShadowBias.xxx + u_xlat1.xyz;
                        u_xlat0.x = dot(vec3(_LightDirection.x, _LightDirection.y, _LightDirection.z), u_xlat6.xyz);
                        u_xlat0.x = clamp(u_xlat0.x, 0.0, 1.0);
                        u_xlat0.x = (-u_xlat0.x) + 1.0;
                        u_xlat0.x = u_xlat0.x * _ShadowBias.y;
                        u_xlat1.xyz = u_xlat6.xyz * u_xlat0.xxx + u_xlat1.xyz;
                        vs_INTERP1.xyz = u_xlat6.xyz;
                        u_xlat0 = u_xlat1.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat1.xxxx + u_xlat0;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat1.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_MatrixVP[3];
                        gl_Position.z = max(u_xlat0.z, -1.0);
                        gl_Position.xyw = u_xlat0.xyw;
                        vs_INTERP0 = in_TEXCOORD0;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec2 _GlobalMipBias;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in highp vec4 vs_INTERP0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_TARGET0;
                    #else
                    layout(location = 0) out highp vec4 SV_TARGET0;
                    #endif
                    float u_xlat0;
                    bool u_xlatb0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_INTERP0.xy, _GlobalMipBias.x).w;
                        u_xlat0 = u_xlat0 + (-_Cutout_Threshold);
                        u_xlatb0 = u_xlat0<0.0;
                        if(u_xlatb0){discard;}
                        SV_TARGET0 = vec4(0.0, 0.0, 0.0, 0.0);
                        return;
                    }
                    
                    #endif
                    "
                }
                SubProgram "gles3 " {
                    Keywords { "_CASTING_PUNCTUAL_LIGHT_SHADOW" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 _TimeParameters;
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	vec4 _ShadowBias;
                    uniform 	vec3 _LightPosition;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(1) uniform UnityPerDraw {
                    #endif
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_ObjectToWorld[4];
                    	UNITY_UNIFORM vec4                hlslcc_mtx4x4unity_WorldToObject[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LODFade;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_WorldTransformParams;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RenderingLayer;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightData;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightIndices[2];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_ProbesOcclusion;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_HDR;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube0_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMax;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_BoxMin;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SpecCube1_ProbePosition;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_LightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_DynamicLightmapST;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHAb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBr;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBg;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHBb;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_SHC;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Min;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_RendererBounds_Max;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousM[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXhlslcc_mtx4x4unity_MatrixPreviousMI[4];
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedXunity_MotionVectorsParams;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    in highp vec3 in_POSITION0;
                    in highp vec3 in_NORMAL0;
                    in highp vec4 in_TEXCOORD0;
                    out highp vec4 vs_INTERP0;
                    out highp vec3 vs_INTERP1;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    vec3 u_xlat2;
                    ivec2 u_xlati2;
                    vec4 u_xlat3;
                    ivec4 u_xlati3;
                    uvec2 u_xlatu3;
                    vec4 u_xlat4;
                    vec3 u_xlat5;
                    vec3 u_xlat6;
                    vec3 u_xlat9;
                    vec2 u_xlat12;
                    ivec2 u_xlati12;
                    uint u_xlatu12;
                    vec2 u_xlat14;
                    ivec2 u_xlati14;
                    uvec2 u_xlatu14;
                    float u_xlat18;
                    int u_xlati18;
                    uint u_xlatu18;
                    float u_xlat19;
                    int u_xlati19;
                    uint u_xlatu19;
                    void main()
                    {
                        u_xlat0.xy = _Wind_Direction.zy * vec2(1.0, 0.0);
                        u_xlat0 = _Wind_Direction.yxyx * vec4(0.0, 1.0, 0.0, 1.0) + (-u_xlat0.xyxy);
                        u_xlat1.xyz = in_POSITION0.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * in_POSITION0.xxx + u_xlat1.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * in_POSITION0.zzz + u_xlat1.xyz;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat0.x = dot(u_xlat0.xzyw, u_xlat1.xxzz);
                        u_xlat6.x = dot(_Wind_Direction.xyz, u_xlat1.xyz);
                        u_xlat0.x = u_xlat6.x * 30.0 + u_xlat0.x;
                        u_xlat0.y = fract(u_xlat0.x);
                        u_xlat0.z = _TimeParameters.x + _TimeParameters.x;
                        u_xlat2.xy = floor(u_xlat0.zx);
                        u_xlat0.x = fract(u_xlat0.z);
                        u_xlat12.xy = u_xlat2.xy + vec2(1.0, 1.0);
                        u_xlati12.xy = ivec2(u_xlat12.xy);
                        u_xlati18 = int(uint(uint(u_xlati12.y) ^ 1103515245u));
                        u_xlati12.x = u_xlati18 + u_xlati12.x;
                        u_xlatu12 = uint(u_xlati18) * uint(u_xlati12.x);
                        u_xlatu18 = uint(u_xlatu12 >> (5u & uint(0x1F)));
                        u_xlati12.x = int(uint(u_xlatu18 ^ u_xlatu12));
                        u_xlatu12 = uint(u_xlati12.x) * 668265261u;
                        u_xlatu12 = uint(u_xlatu12 >> (8u & uint(0x1F)));
                        u_xlat12.x = float(u_xlatu12);
                        u_xlat3.yz = u_xlat12.xx * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat18 = floor(u_xlat3.y);
                        u_xlat3.x = u_xlat12.x * 5.96046519e-08 + (-u_xlat18);
                        u_xlat12.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat12.x = inversesqrt(u_xlat12.x);
                        u_xlat12.xy = u_xlat12.xx * u_xlat3.xz;
                        u_xlat14.xy = u_xlat0.xy + vec2(-1.0, -1.0);
                        u_xlat12.x = dot(u_xlat12.xy, u_xlat14.xy);
                        u_xlat3 = u_xlat2.xyxy + vec4(0.0, 1.0, 1.0, 0.0);
                        u_xlati2.xy = ivec2(u_xlat2.xy);
                        u_xlati3 = ivec4(u_xlat3);
                        u_xlati14.xy = ivec2(uvec2(uint(u_xlati3.y) ^ uint(1103515245u), uint(u_xlati3.w) ^ uint(1103515245u)));
                        u_xlati3.xy = u_xlati14.xy + u_xlati3.xz;
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(u_xlati3.xy);
                        u_xlatu3.xy = uvec2(u_xlatu14.x >> (uint(5u) & uint(0x1F)), u_xlatu14.y >> (uint(5u) & uint(0x1F)));
                        u_xlati14.xy = ivec2(uvec2(u_xlatu14.x ^ u_xlatu3.x, u_xlatu14.y ^ u_xlatu3.y));
                        u_xlatu14.xy = uvec2(u_xlati14.xy) * uvec2(668265261u, 668265261u);
                        u_xlatu14.xy = uvec2(u_xlatu14.x >> (uint(8u) & uint(0x1F)), u_xlatu14.y >> (uint(8u) & uint(0x1F)));
                        u_xlat14.xy = vec2(u_xlatu14.xy);
                        u_xlat3 = u_xlat14.xyxy * vec4(5.96046519e-08, 5.96046519e-08, 5.96046519e-08, 5.96046519e-08) + vec4(0.5, 0.5, -0.5, -0.5);
                        u_xlat4.xy = floor(u_xlat3.xy);
                        u_xlat3.xy = u_xlat14.xy * vec2(5.96046519e-08, 5.96046519e-08) + (-u_xlat4.xy);
                        u_xlat18 = dot(u_xlat3.yw, u_xlat3.yw);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat14.xy = vec2(u_xlat18) * u_xlat3.yw;
                        u_xlat4 = u_xlat0.xyxy + vec4(-0.0, -1.0, -1.0, -0.0);
                        u_xlat18 = dot(u_xlat14.xy, u_xlat4.zw);
                        u_xlat12.x = (-u_xlat18) + u_xlat12.x;
                        u_xlat14.xy = u_xlat0.xy * u_xlat0.xy;
                        u_xlat14.xy = u_xlat0.xy * u_xlat14.xy;
                        u_xlat9.xz = u_xlat0.xy * vec2(6.0, 6.0) + vec2(-15.0, -15.0);
                        u_xlat9.xz = u_xlat0.xy * u_xlat9.xz + vec2(10.0, 10.0);
                        u_xlat14.xy = u_xlat14.xy * u_xlat9.xz;
                        u_xlat12.x = u_xlat14.y * u_xlat12.x + u_xlat18;
                        u_xlati18 = int(uint(uint(u_xlati2.y) ^ 1103515245u));
                        u_xlati19 = u_xlati18 + u_xlati2.x;
                        u_xlatu18 = uint(u_xlati18) * uint(u_xlati19);
                        u_xlatu19 = uint(u_xlatu18 >> (5u & uint(0x1F)));
                        u_xlati18 = int(uint(u_xlatu18 ^ u_xlatu19));
                        u_xlatu18 = uint(u_xlati18) * 668265261u;
                        u_xlatu18 = uint(u_xlatu18 >> (8u & uint(0x1F)));
                        u_xlat18 = float(u_xlatu18);
                        u_xlat5.yz = vec2(u_xlat18) * vec2(5.96046519e-08, 5.96046519e-08) + vec2(0.5, -0.5);
                        u_xlat19 = floor(u_xlat5.y);
                        u_xlat5.x = u_xlat18 * 5.96046519e-08 + (-u_xlat19);
                        u_xlat18 = dot(u_xlat5.xz, u_xlat5.xz);
                        u_xlat18 = inversesqrt(u_xlat18);
                        u_xlat2.xy = vec2(u_xlat18) * u_xlat5.xz;
                        u_xlat0.x = dot(u_xlat2.xy, u_xlat0.xy);
                        u_xlat6.x = dot(u_xlat3.xz, u_xlat3.xz);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xz = u_xlat6.xx * u_xlat3.xz;
                        u_xlat6.x = dot(u_xlat6.xz, u_xlat4.xy);
                        u_xlat6.x = (-u_xlat0.x) + u_xlat6.x;
                        u_xlat0.x = u_xlat14.y * u_xlat6.x + u_xlat0.x;
                        u_xlat6.x = (-u_xlat0.x) + u_xlat12.x;
                        u_xlat0.x = u_xlat14.x * u_xlat6.x + u_xlat0.x;
                        u_xlat0.x = u_xlat0.x + 1.29999995;
                        u_xlat0.x = u_xlat0.x * 0.555555582;
                        u_xlat0.x = clamp(u_xlat0.x, 0.0, 1.0);
                        u_xlat6.x = u_xlat0.x * -2.0 + 3.0;
                        u_xlat0.x = u_xlat0.x * u_xlat0.x;
                        u_xlat0.x = dot(u_xlat6.xx, u_xlat0.xx);
                        u_xlat2.x = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[0].xyz);
                        u_xlat2.y = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[1].xyz);
                        u_xlat2.z = dot(in_NORMAL0.xyz, hlslcc_mtx4x4unity_WorldToObject[2].xyz);
                        u_xlat6.x = dot(u_xlat2.xyz, u_xlat2.xyz);
                        u_xlat6.x = max(u_xlat6.x, 1.17549435e-38);
                        u_xlat6.x = inversesqrt(u_xlat6.x);
                        u_xlat6.xyz = u_xlat6.xxx * u_xlat2.xyz;
                        u_xlat19 = dot(_Wind_Direction.xyz, u_xlat6.xyz);
                        u_xlat19 = abs(u_xlat19) + -1.0;
                        u_xlat19 = _Wind_Normal_Factor * u_xlat19 + 1.0;
                        u_xlat0.x = u_xlat0.x * u_xlat19;
                        u_xlat19 = u_xlat1.y + (-_Ground_Height);
                        u_xlat2.x = (-_Ground_Height) + _Grass_Height;
                        u_xlat2.x = float(1.0) / u_xlat2.x;
                        u_xlat19 = u_xlat19 * u_xlat2.x;
                        u_xlat19 = clamp(u_xlat19, 0.0, 1.0);
                        u_xlat2.x = u_xlat19 * -2.0 + 3.0;
                        u_xlat19 = u_xlat19 * u_xlat19;
                        u_xlat19 = u_xlat19 * u_xlat2.x;
                        u_xlat0.x = u_xlat0.x * u_xlat19;
                        u_xlat0.x = u_xlat0.x * _Wind_Displacement;
                        u_xlat1.xyz = u_xlat0.xxx * _Wind_Direction.xyz + u_xlat1.xyz;
                        u_xlat2.xyz = u_xlat1.yyy * hlslcc_mtx4x4unity_WorldToObject[1].xyz;
                        u_xlat1.xyw = hlslcc_mtx4x4unity_WorldToObject[0].xyz * u_xlat1.xxx + u_xlat2.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_WorldToObject[2].xyz * u_xlat1.zzz + u_xlat1.xyw;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_WorldToObject[3].xyz;
                        u_xlat2.xyz = u_xlat1.yyy * hlslcc_mtx4x4unity_ObjectToWorld[1].xyz;
                        u_xlat1.xyw = hlslcc_mtx4x4unity_ObjectToWorld[0].xyz * u_xlat1.xxx + u_xlat2.xyz;
                        u_xlat1.xyz = hlslcc_mtx4x4unity_ObjectToWorld[2].xyz * u_xlat1.zzz + u_xlat1.xyw;
                        u_xlat1.xyz = u_xlat1.xyz + hlslcc_mtx4x4unity_ObjectToWorld[3].xyz;
                        u_xlat2.xyz = (-u_xlat1.xyz) + _LightPosition.xyz;
                        u_xlat0.x = dot(u_xlat2.xyz, u_xlat2.xyz);
                        u_xlat0.x = inversesqrt(u_xlat0.x);
                        u_xlat2.xyz = u_xlat0.xxx * u_xlat2.xyz;
                        u_xlat0.x = dot(u_xlat2.xyz, u_xlat6.xyz);
                        u_xlat0.x = clamp(u_xlat0.x, 0.0, 1.0);
                        u_xlat1.xyz = u_xlat2.xyz * _ShadowBias.xxx + u_xlat1.xyz;
                        u_xlat0.x = (-u_xlat0.x) + 1.0;
                        u_xlat0.x = u_xlat0.x * _ShadowBias.y;
                        u_xlat1.xyz = u_xlat6.xyz * u_xlat0.xxx + u_xlat1.xyz;
                        vs_INTERP1.xyz = u_xlat6.xyz;
                        u_xlat0 = u_xlat1.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat1.xxxx + u_xlat0;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat1.zzzz + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_MatrixVP[3];
                        gl_Position.z = max(u_xlat0.z, -1.0);
                        gl_Position.xyw = u_xlat0.xyw;
                        vs_INTERP0 = in_TEXCOORD0;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec2 _GlobalMipBias;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform UnityPerMaterial {
                    #endif
                    	UNITY_UNIFORM vec3                _Wind_Direction;
                    	UNITY_UNIFORM float                _Cutout_Threshold;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MainTex_TexelSize;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Tint;
                    	UNITY_UNIFORM float                _Ground_Height;
                    	UNITY_UNIFORM float                _Grass_Height;
                    	UNITY_UNIFORM float                _Wind_Displacement;
                    	UNITY_UNIFORM float                _Wind_Normal_Factor;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in highp vec4 vs_INTERP0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_TARGET0;
                    #else
                    layout(location = 0) out highp vec4 SV_TARGET0;
                    #endif
                    float u_xlat0;
                    bool u_xlatb0;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_INTERP0.xy, _GlobalMipBias.x).w;
                        u_xlat0 = u_xlat0 + (-_Cutout_Threshold);
                        u_xlatb0 = u_xlat0<0.0;
                        if(u_xlatb0){discard;}
                        SV_TARGET0 = vec4(0.0, 0.0, 0.0, 0.0);
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
        Pass {
            Name "GBuffer"
            Tags { "DisableBatching" = "False" "LIGHTMODE" = "UniversalGBuffer" "QUEUE" = "AlphaTest" "RenderPipeline" = "UniversalPipeline" "RenderType" = "Opaque" "ShaderGraphShader" = "true" "ShaderGraphTargetId" = "UniversalUnlitSubTarget" "UniversalMaterialType" = "Unlit" }
            Cull Off
            GpuProgramID 310851
        }
    }
Fallback "Hidden/Shader Graph/FallbackError"
CustomEditor "UnityEditor.ShaderGraph.GenericShaderGraphMaterialGUI"
}